function varargout = defocusImage(varargin)
% DEFOCUSIMAGE M-file for defocusImage.fig
%      DEFOCUSIMAGE, by itself, creates a new DEFOCUSIMAGE or raises the existing
%      singleton*.
%
%      H = DEFOCUSIMAGE returns the handle to a new DEFOCUSIMAGE or the handle to
%      the existing singleton*.
%
%      DEFOCUSIMAGE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in DEFOCUSIMAGE.M with the given input arguments.
%
%      DEFOCUSIMAGE('Property','Value',...) creates a new DEFOCUSIMAGE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before defocusImage_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to defocusImage_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help defocusImage

% Last Modified by GUIDE v2.5 08-May-2012 09:13:30

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @defocusImage_OpeningFcn, ...
                   'gui_OutputFcn',  @defocusImage_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before defocusImage is made visible.
function defocusImage_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to defocusImage (see VARARGIN)

% Choose default command line output for defocusImage
handles.output = hObject;

img = (255-double(imread('smiley.jpg')))/255;
scale = sum(sum(img));
dx = 0.1;

[Ny,Nx] = size(img);
imagesc(dx*[0:Nx-1],dx*[0:Ny-1],img); axis equal; axis tight; colormap('gray'); pause(1);
handles.img = sqrt(img);
handles.dx = dx;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes defocusImage wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = defocusImage_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes on selection change in popupmenu_Object.
function popupmenu_Object_Callback(hObject, eventdata, handles)
switch get(handles.popupmenu_Object,'Value')
    case 1 % Smiley
        img = (255-double(imread('smiley.jpg')))/255;
        scale = sum(sum(img));
    case 2 % big slit
        img = zeros(500);
        img(50:450,150:350) = 1;        
    case 3 % Edge
        img = zeros(500);
        img(:,301:500) = 1;
        img(:,1:201) = 1;
    case 4 % Disc
        img = ones(500);
        r2 = repmat([-250:249].^2,500,1)+repmat(([-250:249].^2).',1,500);
        img(find(r2<60^2)) = 0;
    case 5 % Hole
        img = zeros(500);
        r2 = repmat([-250:249].^2,500,1)+repmat(([-250:249].^2).',1,500);
        img(find(r2<60^2)) = 1;
    case 6 % array of square holes
        img = zeros(500);
        for i=50:100:450
            for j=50:100:450
                %img(i+[-25:24],j+[-25:24]) = subImg;
                img(i+[-5:5],j+[-5:5]) = 1;
            end
        end        
    case 7 % hole array
        img = zeros(500);
        subImg = zeros(50);
        [xs,ys] = meshgrid([-25:24],[-25:24]);
        size(xs)
        subImg(find(xs.^2+ys.^2) < 15^2) = 1;
        for i=50:100:450
            for j=50:100:450
                %img(i+[-25:24],j+[-25:24]) = subImg;
                img(i+[-25:24],j+[-25:24]) = subImg;
            end
        end
end
dx = 0.1;
[Ny,Nx] = size(img);
imagesc(dx*[0:Nx-1],dx*[0:Ny-1],img); axis equal; axis tight; colormap('gray'); 
xlabel('x in um');
ylabel('y in um');
pause(0.1);
handles.img = sqrt(img);
handles.dx = dx;

% Update handles structure
guidata(hObject, handles);


function edit_Wavelength_Callback(hObject, eventdata, handles)
% hObject    handle to edit_Wavelength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit_Wavelength as text
%        str2double(get(hObject,'String')) returns contents of edit_Wavelength as a double


% --- Executes during object creation, after setting all properties.
function edit_Wavelength_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Wavelength (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function edit_Distance_Callback(hObject, eventdata, handles)
lambda = str2double(get(handles.edit_Wavelength,'String'))*1e-3;
defocus = str2double(get(handles.edit_Distance,'String'));

img = handles.img;
[Ny,Nx] = size(img);
dx = handles.dx;
dkx = 1/(Nx*dx);
dky = 1/(Ny*dx);
qx = ifftshift(dkx*(-Nx/2+[0:Nx-1]));
qy = ifftshift(dky*(-Ny/2+[0:Ny-1].'));
q2 = repmat(qx.^2,Ny,1)+repmat(qy.^2,1,Nx);
imgDef = abs(ifft2(fft2(img).*exp(i*pi*lambda*defocus*q2))).^2;
imagesc(dx*[0:Nx-1],dx*[0:Ny-1],imgDef); axis equal; axis tight; colormap('gray'); 
% caxis([0.4 1.3]);
xlabel('x in um');
ylabel('y in um');
title(sprintf('Defocus: %.1f um, contrast: %.1f .. %.1f\n',defocus,min(min(imgDef)),max(max(imgDef))));
% pause(0.1);


% --- Executes during object creation, after setting all properties.
function edit_Distance_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit_Distance (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end






% --- Executes during object creation, after setting all properties.
function popupmenu_Object_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu_Object (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbutton_FFT.
function pushbutton_FFT_Callback(hObject, eventdata, handles)
img = handles.img;
[Ny,Nx] = size(img);
dx = handles.dx;
dkx = 2*pi/(Nx*dx);
dky = 2*pi/(Ny*dx);
qx = dkx*(-Nx/2+[0:Nx-1]);
qy = dky*(-Ny/2+[0:Ny-1].');
imagesc(qx,qy,log(1+abs(fftshift(fft2(img))))); axis equal; axis tight; colormap('gray'); 
% caxis([0.4 1.3]);
xlabel('k_x in 1/um');
ylabel('k_y in 1/um');
title(sprintf('Fourier Transformation\n'));
% pause(0.1);


